# -*- coding: UTF-8 -*-
import json


def get_tags():
    return ["2", "2.1", "2.1.4", "2.1.4.15"]


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    owner = runcontext.get_extra_var('MONGODB_OWNER')
    mongod = runcontext.get_extra_var('MONGODB_MONGOD')
    if 'root' != owner:
        cmd1 = '''su - %s -s /bin/bash -c "%s -h | grep snmp"''' % (owner, mongod)
    else:
        cmd1 = '''%s -h | grep snmp''' % mongod
    runcontext.set_mod_params_instance(ansible_params, "command", cmd1)
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    if arc1 == -1:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    if astdout1:
        var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
        ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--auditDestination"])
        runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
        if ret_cmd_value:
            tmp_vars["systemvalue1"] = ' '.join([ret_cmd_param, ret_cmd_value])
            tmp_vars["checkresult1"] = "pass"
        else:
            yml_key_list = ["auditLog", "destination"]
            key_list = ["auditDestination"]
            ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
            runcontext.log_debug("ret_conf_value: %s" % str(ret_conf_value))
            if ret_conf_value is not None:
                if var_mongo_parser.type == 'str':
                    tmp_vars["systemvalue1"] = '='.join(key_list) + '=' + ret_conf_value
                else:
                    tmp_vars["systemvalue1"] = '.'.join(yml_key_list) + ': ' + str(ret_conf_value)

                if ret_conf_value:
                    tmp_vars["checkresult1"] = "pass"

        if tmp_vars["checkresult1"] == "pass":
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
    else:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = "Mongodb is Community Version"
        ret_code = 0

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_4_15.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
