﻿# -*- coding: UTF-8 -*-
import json


def get_tags():
    return ['3', '3.1', '3.1.1']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars[
        "scancommand1"] = '''ps -ef | grep "$(netstat -nltp | grep mongo | awk '{print $7}' | awk -F'/' '{print $1}' | uniq)" | awk '{print $1}' '''
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    runcontext.set_mod_params_instance(ansible_params, "command",
                                       tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]

    runcontext.log_debug_json(resultjson1)

    astdout1 = astdout1.split(' ', 1)[0].strip()

    if astdout1.strip() == 'root':
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0

    rc, out = curtemplate.render(runcontext.get_template_file('r_3_1_1.j2'),
                                 **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)
    return ret_code, out
