# -*- coding: UTF-8 -*-
import json
import re


def get_tags():
    return ["3", "3.1", "3.1.2"]


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}

    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
    ret_cmd_param2, ret_cmd_value2 = var_mongo_parser.get_cmd_value(["--keyFile"])
    runcontext.log_debug("ret_cmd_param2: %s  ret_cmd_value2: %s" % (ret_cmd_param2, ret_cmd_value2))
    if len(ret_cmd_value2) != 0:
        keyfile_path = ret_cmd_value2
    else:
        yml_key_list2 = ["security", "keyFile"]
        key_list2 = ["keyFile"]
        keyfile_path = var_mongo_parser.get_conf_value(yml_key_list2, key_list2)
        runcontext.log_debug("ret_conf_value2: %s" % keyfile_path)

    if keyfile_path == '' or keyfile_path == "None" or keyfile_path is None:
        tmp_vars["systemvalue1"] = "No key file is set."
    else:
        # 获取配置文件属主
        owner_group_cmd = '''stat -c "%s:%s" %s''' % ("%U", "%G", var_mongo_parser)
        runcontext.set_mod_params_instance(ansible_params, "command",
                                           owner_group_cmd)
        arc1, astdout1, astderr1 = runcontext.invoke_module(module,
                                                            ansible_params)
        runcontext.sleep()
        if arc1 != 0:
            return (-2, "Failed to invoke module: %s." % astdout1)
        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]

        # 获取keyFile权限和属主
        permission_cmd = '''stat -c "%s %s:%s %s" %s''' % ("%n", "%U", "%G", "%a", keyfile_path)
        runcontext.set_mod_params_instance(ansible_params, "command",
                                           permission_cmd)
        arc2, astdout2, astderr2 = runcontext.invoke_module(module,
                                                            ansible_params)
        runcontext.sleep()
        if arc2 != 0:
            return (-2, "Failed to invoke module: %s." % astdout2)
        resultjson2 = json.loads(astdout2)
        astdout2 = resultjson2["stdout"]
        tmp_vars["systemvalue1"] = astdout2

        if len(astdout2.split()) == 3:
            permission_UG = astdout2.split()[1]
            permission_a = astdout2.split()[2]
            if re.search(astdout1, permission_UG):
                if re.search(r"[0246]00", permission_a):
                    tmp_vars["checkresult1"] = "pass"

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0

    rc, out = curtemplate.render(runcontext.get_template_file('r_3_1_2.j2'),
                                 **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)
    return ret_code, out

