# -*- coding: UTF-8 -*-
import json
import re


def get_tags():
    return ["3", "3.1", "3.1.3"]


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    keyFile_path = ''
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["systemvalue2"] = ""
    ret_code = -1

    # 资源限制 ulimit
    # n（打开的文件）
    ulimit_n = '''ulimit -n'''
    runcontext.set_mod_params_instance(ansible_params, "command",
                                       ulimit_n)
    arc1, astdout1, astderr1 = runcontext.invoke_module(module,
                                                        ansible_params)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    tmp_vars["systemvalue2"] = astdout1

    # u（进程/线程）
    ulimit_u = '''ulimit -u'''
    runcontext.set_mod_params_instance(ansible_params, "command",
                                       ulimit_u)
    arc2, astdout2, astderr2 = runcontext.invoke_module(module,
                                                        ansible_params)
    runcontext.sleep()
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s." % astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    tmp_vars["systemvalue2"] = astdout2

    if astdout1.lower != "unlimited":
        if int(astdout1) < 64000:
            tmp_vars["checkresult1"] = "pass"
    if astdout2.lower != "unlimited":
        if int(astdout2) < 64000:
            tmp_vars["checkresult2"] = "pass"

    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0

    rc, out = curtemplate.render(runcontext.get_template_file('r_3_1_3.j2'),
                                 **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)
    return ret_code, out

