# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ["2", "2.1", "2.1.4", "2.1.4.3"]


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--port"])
    runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
    if len(ret_cmd_value) != 0:
        tmp_vars["systemvalue1"] = ' '.join([ret_cmd_param, ret_cmd_value])
        if ret_cmd_value.isdigit():
            if ret_cmd_value not in ['27017', '27018', '27019'] and int(ret_cmd_value) in range(65536):
                tmp_vars["checkresult1"] = "pass"
    else:
        yml_key_list = ["net", "port"]
        key_list = ["port"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value: %s" % str(ret_conf_value))
        if ret_conf_value is not None:
            tmp_vars["systemvalue1"] = ret_conf_value
            if str(ret_conf_value).isdigit() and re.search(r"2701[7-9]", str(ret_conf_value)) is None and int(ret_conf_value) in range(65536):
                tmp_vars["checkresult1"] = "pass"

    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_4_3.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
