# -*- coding: UTF-8 -*-


def get_tags():
    return ["2", "2.1", "2.1.5", "2.1.5.1"]


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["systemvalue2"] = ""
    ret_code = -1

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--auth"])
    runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
    if len(ret_cmd_param) != 0:
        tmp_vars["systemvalue1"] = ' '.join([ret_cmd_param, ret_cmd_value])
        tmp_vars["checkresult1"] = "pass"
    else:
        yml_key_list = ["security", "authorization"]
        key_list = ["auth"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value: %s" % ret_conf_value)
        if ret_conf_value is not None:
            if var_mongo_parser.type == 'str':  # key value type
                tmp_vars["systemvalue1"] = '='.join(key_list) + "=" + ret_conf_value
                if ret_conf_value.lower() in ["true", "on", "yes", "1"]:
                    tmp_vars["checkresult1"] = "pass"
            else:  # yaml type
                tmp_vars["systemvalue1"] = '.'.join(yml_key_list) + ": " + ret_conf_value
                if ret_conf_value == "enabled":
                    tmp_vars["checkresult1"] = "pass"

    ret_cmd_param2, ret_cmd_value2 = var_mongo_parser.get_cmd_value(["--keyFile"])
    runcontext.log_debug("ret_cmd_param2: %s  ret_cmd_value2: %s" % (ret_cmd_param2, ret_cmd_value2))
    if len(ret_cmd_value2) != 0:
        tmp_vars["systemvalue2"] = ' '.join([ret_cmd_param2, ret_cmd_value2])
        if ret_cmd_value2 != "":
            tmp_vars["checkresult2"] = "pass"
    else:
        yml_key_list2 = ["security", "keyFile"]
        key_list2 = ["keyFile"]
        ret_conf_value2 = var_mongo_parser.get_conf_value(yml_key_list2, key_list2)
        runcontext.log_debug("ret_conf_value2: %s" % ret_conf_value2)
        if ret_conf_value2 is not None:
            if var_mongo_parser.type == 'str':
                tmp_vars["systemvalue2"] = '='.join(key_list2) + "=" + ret_conf_value2
            else:
                tmp_vars["systemvalue2"] = '.'.join(yml_key_list2) + ": " + ret_conf_value2
            if ret_conf_value2:
                tmp_vars["checkresult2"] = "pass"

    if tmp_vars["checkresult1"] == "pass" or tmp_vars["checkresult2"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_5_1.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
