# -*- coding: UTF-8 -*-
def get_tags():
    return ["2", "2.1", "2.1.5", "2.1.5.5"]


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["systemvalue2"] = ""
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["systemvalue3"] = ""
    tmp_vars["checkresult4"] = "failed"
    tmp_vars["systemvalue4"] = ""
    ret_code = -1

    bool_sslMode = False
    bool_sslOnNormalPorts = False

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')

    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--sslMode"])
    runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
    if ret_cmd_value:
        if ret_cmd_value in ['requireSSL']:
            bool_sslMode = True
    else:
        yml_key_list = ["net", "ssl", "mode"]
        key_list = ["sslMode"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value: %s" % ret_conf_value)
        if ret_conf_value is not None:
            if ret_conf_value in ['requireSSL']:
                bool_sslMode = True

    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--sslOnNormalPorts"])
    runcontext.log_debug("ret_cmd_param2: %s  ret_cmd_value2: %s" % (ret_cmd_param, ret_cmd_value))
    if ret_cmd_param:
        bool_sslOnNormalPorts = True
    else:
        yml_key_list = ["net", "ssl", "sslOnNormalPorts"]
        key_list = ["sslOnNormalPorts"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value2: %s" % str(ret_conf_value))
        if ret_conf_value is not None:
            if str(ret_conf_value).lower() in ['on', 'yes', 'true', '1'] or ret_conf_value in ['requireSSL']:
                bool_sslOnNormalPorts = True

    if bool_sslMode ^ bool_sslOnNormalPorts:
        ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--sslWeakCertificateValidation"])
        runcontext.log_debug("ret_cmd_param3: %s  ret_cmd_value3: %s" % (ret_cmd_param, ret_cmd_value))
        if ret_cmd_param:
            tmp_vars["systemvalue1"] = ' '.join([ret_cmd_param, ret_cmd_value])
            tmp_vars["checkresult1"] = "pass"
        else:
            yml_key_list = ["net", "ssl", "weakCertificateValidation"]
            key_list = ["sslWeakCertificateValidation"]
            ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
            runcontext.log_debug("ret_conf_value3: %s" % str(ret_conf_value))
            if ret_conf_value is not None:
                if var_mongo_parser.type == 'str':
                    tmp_vars["systemvalue1"] = '='.join(key_list) + '=' + ret_conf_value
                    if ret_conf_value.lower() in ('on', '1', 'true', 'yes'):
                        tmp_vars["checkresult1"] = "pass"
                else:
                    tmp_vars["systemvalue1"] = '.'.join(yml_key_list) + ': ' + str(ret_conf_value).lower()
                    if str(ret_conf_value).lower() in ('on', '1', 'true', 'yes'):
                        tmp_vars["checkresult1"] = "pass"

        ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--sslAllowInvalidCertificates"])
        runcontext.log_debug("ret_cmd_param4: %s  ret_cmd_value4: %s" % (ret_cmd_param, ret_cmd_value))
        if ret_cmd_param:
            tmp_vars["systemvalue2"] = ' '.join([ret_cmd_param, ret_cmd_value])
            tmp_vars["checkresult2"] = "pass"
        else:
            yml_key_list = ["net", "ssl", "allowInvalidCertificates"]
            key_list = ["sslAllowInvalidCertificates"]
            ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
            runcontext.log_debug("ret_conf_value4: %s" % str(ret_conf_value))
            if ret_conf_value is not None:
                if var_mongo_parser.type == "str":
                    tmp_vars["systemvalue2"] = '='.join(key_list) + '=' + ret_conf_value
                    if ret_conf_value.lower() in ('on', '1', 'true', 'yes'):
                        tmp_vars["checkresult2"] = "pass"
                else:
                    tmp_vars["systemvalue2"] = '.'.join(yml_key_list) + ': ' + str(ret_conf_value).lower()
                    if str(ret_conf_value).lower() in ('on', '1', 'true', 'yes'):
                        tmp_vars["checkresult2"] = "pass"

        ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--sslCRLFile"])
        runcontext.log_debug("ret_cmd_param5: %s  ret_cmd_value5: %s" % (ret_cmd_param, ret_cmd_value))
        if tmp_vars["checkresult1"] == "pass" or tmp_vars["checkresult2"] == "pass":
            if ret_cmd_value:
                tmp_vars["systemvalue3"] = ' '.join([ret_cmd_param, ret_cmd_value])
                tmp_vars["checkresult3"] = "pass"
                ret_code = 0
                tmp_vars["policyresult"] = "pass"
            else:
                yml_key_list = ["net", "ssl", "CRLFile"]
                key_list = ["sslCRLFile"]
                ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
                runcontext.log_debug("ret_conf_value5: %s" % ret_conf_value)
                if ret_conf_value is not None:
                    if var_mongo_parser.type == "str":
                        tmp_vars["systemvalue3"] = '='.join(key_list) + '=' + ret_conf_value
                    else:
                        tmp_vars["systemvalue3"] = '.'.join(yml_key_list) + ': ' + ret_conf_value

                    if ret_conf_value:
                        tmp_vars["checkresult3"] = "pass"
                        ret_code = 0
                        tmp_vars["policyresult"] = "pass"
        else:
            tmp_vars["checkresult4"] = "pass"
            tmp_vars["systemvalue4"] = "sslWeakCertificateValidation and sslAllowInvalidCertificates are not enabled"
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
    else:
        ret_code = 0
        tmp_vars["systemvalue1"] = "SSL is not enable"
        tmp_vars["systemvalue2"] = "SSL is not enable"
        tmp_vars["systemvalue3"] = "SSL is not enable"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_5_5.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
