# -*- coding: UTF-8 -*-
def get_tags():
    return ["2", "2.1", "2.1.6", "2.1.6.1"]


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--quiet"])
    runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
    if ret_cmd_param:
        tmp_vars["systemvalue1"] = ret_cmd_param
    else:
        yml_key_list = ["systemLog", "quiet"]
        key_list = ["quiet"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value: %s" % str(ret_conf_value))
        if ret_conf_value is not None:
            if var_mongo_parser.type == 'str':  # key value type
                tmp_vars["systemvalue1"] = '='.join(key_list) + '=' + ret_conf_value
                if ret_conf_value.lower() in ["false", "0", "no", "off"]:
                    tmp_vars["checkresult1"] = "pass"
            else:  # yaml type
                tmp_vars["systemvalue1"] = '.'.join(yml_key_list) + ': ' + str(ret_conf_value).lower()
                if str(ret_conf_value).lower() in ["false", "0", "no", "off"]:
                    tmp_vars["checkresult1"] = "pass"
        else:
            tmp_vars["checkresult1"] = "pass"

    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_6_1.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
