# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ["2", "2.2", "2.2.1", "2.2.1.2"]


def run_task(runcontext):
    mongodb_bin = runcontext.get_extra_var('MONGODB_MONGOD')
    mongodb_bin = os.path.split(mongodb_bin)[0]
    mongodb_bin = runcontext.replace_inject_characters(mongodb_bin)
    runcontext.log_debug("mongodb_bin: %s" % mongodb_bin)
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
    runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_2_1_2.json'))
    runcontext.set_mod_params_instance(ansible_params, 'path', mongodb_bin)
    runcontext.set_mod_params_instance(ansible_params, 'owner', '!root')
    runcontext.set_mod_params_instance(ansible_params, 'group', '!root')
    runcontext.set_mod_params_instance(ansible_params, 'group_r', False)
    runcontext.set_mod_params_instance(ansible_params, 'group_w', False)
    runcontext.set_mod_params_instance(ansible_params, 'group_x', False)
    runcontext.set_mod_params_instance(ansible_params, 'other_r', False)
    runcontext.set_mod_params_instance(ansible_params, 'other_w', False)
    runcontext.set_mod_params_instance(ansible_params, 'other_x', False)

    module = runcontext.get_module_file('file_permission.py')
    rc1, stdout, stderr = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc1, stdout, stderr)

    resultjson = json.loads(str(stdout))

    ret_code = -1
    ret_msg = ''

    #run failed
    if 'failed' in resultjson:
        ret_code = -2
        ret_msg = resultjson['msg']
    elif 'result' in resultjson:
        tmp_vars = {}
        curtemplate = runcontext.get_template()
        result = resultjson['result']
        if result == True:
            ret_code = 0
            tmp_vars['policyresult'] = 'pass'
            tmp_vars['checkresult1'] = 'pass'
        else:
            tmp_vars['policyresult'] = 'failed'
            tmp_vars['checkresult1'] = 'failed'

        tmp_vars['file_owner'] = ""
        tmp_vars['file_group'] = ""
        tmp_vars['file_mode'] = ""

        if 'items' in resultjson:
            if 'owner' in resultjson['items']:
                tmp_vars['file_owner'] = resultjson['items']['owner']
            if 'group' in resultjson['items']:
                tmp_vars['file_group'] = resultjson['items']['group']
            if 'mode' in resultjson['items']:
                tmp_vars['file_mode'] = resultjson['items']['mode']

        rc1, out = curtemplate.render(runcontext.get_template_file('r_2_2_1_2.j2'), **tmp_vars)

        if rc1 == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    else:
        ret_code = -2
        ret_msg = 'Result format is incorrect.'

    return ret_code, ret_msg
