# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ["2", "2.2", "2.2.1", "2.2.1.4"]


def run_task(runcontext):
    tmp_vars = {}
    tmp_vars['file_owner'] = ""
    tmp_vars['file_group'] = ""
    tmp_vars['file_mode'] = ""
    ret_code = -1

    curtemplate = runcontext.get_template()
    mongodb_config = runcontext.get_extra_var('MONGODB_CONFIG')
    mongodb_config = runcontext.replace_inject_characters(mongodb_config)
    runcontext.log_debug("mongodb_config: %s" % mongodb_config)
    if mongodb_config == "":
        ret_code = 0
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
    else:
        ansible_params = runcontext.get_mod_params_instance()
        runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
        runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
        runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_2_1_4.json'))
        runcontext.set_mod_params_instance(ansible_params, 'path', mongodb_config)
        runcontext.set_mod_params_instance(ansible_params, 'owner', '!root')
        runcontext.set_mod_params_instance(ansible_params, 'group', '!root')
        runcontext.set_mod_params_instance(ansible_params, 'owner_x', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_x', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_x', False)

        module = runcontext.get_module_file('file_permission.py')
        rc1, stdout, stderr = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(rc1, stdout, stderr)
        resultjson = json.loads(str(stdout))

        ret_msg = ''
        #run failed
        if 'failed' in resultjson:
            ret_code = -2
            ret_msg = resultjson['msg']
        elif 'result' in resultjson:
            result = resultjson['result']
            if result == True:
                ret_code = 0
                tmp_vars['policyresult'] = 'pass'
                tmp_vars['checkresult1'] = 'pass'
            else:
                tmp_vars['policyresult'] = 'failed'
                tmp_vars['checkresult1'] = 'failed'

            if 'items' in resultjson:
                if 'owner' in resultjson['items']:
                    tmp_vars['file_owner'] = resultjson['items']['owner']
                if 'group' in resultjson['items']:
                    tmp_vars['file_group'] = resultjson['items']['group']
                if 'mode' in resultjson['items']:
                    tmp_vars['file_mode'] = resultjson['items']['mode']
        else:
            ret_code = -2
            ret_msg = 'Result format is incorrect.'

    rc1, out = curtemplate.render(runcontext.get_template_file('r_2_2_1_4.j2'), **tmp_vars)
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
