# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ["2", "2.2", "2.2.1", "2.2.1.5"]


def run_task(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}

    tmp_vars['checkvalue1'] = ""
    owner = ""
    group = ""
    mode = ""
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    ret_code = -1

    var_mongo_parser = runcontext.get_parameter('_mongo_conf_parse')
    mongodb_logfile = ''
    ret_cmd_param, ret_cmd_value = var_mongo_parser.get_cmd_value(["--logpath"])
    runcontext.log_debug("ret_cmd_param: %s  ret_cmd_value: %s" % (ret_cmd_param, ret_cmd_value))
    if ret_cmd_value != "":
        mongodb_logfile = ret_cmd_value
    else:
        yml_key_list = ["systemLog", "path"]
        key_list = ["logpath"]
        ret_conf_value = var_mongo_parser.get_conf_value(yml_key_list, key_list)
        runcontext.log_debug("ret_conf_value: %s" % str(ret_conf_value))
        if ret_conf_value is not None:
            mongodb_logfile = ret_conf_value
    if mongodb_logfile == "":
        mongodb_logfile = "/var/log/mongodb/mongodb.log"
    mongodb_logfile = runcontext.replace_inject_characters(mongodb_logfile)
    runcontext.log_debug("mongodb_logfile: %s" % mongodb_logfile)

    if not os.path.exists(mongodb_logfile):
        ret_code = 0
        tmp_vars['checkvalue1'] = "log file %s does not exist" % mongodb_logfile
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
    else:
        ansible_params = runcontext.get_mod_params_instance()
        runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
        runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
        runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_2_1_5.json'))
        runcontext.set_mod_params_instance(ansible_params, 'path', mongodb_logfile)
        runcontext.set_mod_params_instance(ansible_params, 'owner', '!root')
        runcontext.set_mod_params_instance(ansible_params, 'group', '!root')
        runcontext.set_mod_params_instance(ansible_params, 'owner_x', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_x', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_x', False)

        module = runcontext.get_module_file('file_permission.py')
        rc1, stdout, stderr = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(rc1, stdout, stderr)
        resultjson = json.loads(str(stdout))

        ret_msg = ''

        #run failed
        if 'failed' in resultjson:
            ret_code = -2
            ret_msg = resultjson['msg']
        elif 'result' in resultjson:
            result = resultjson['result']
            if result == True:
                ret_code = 0
                tmp_vars['policyresult'] = 'pass'
                tmp_vars['checkresult1'] = 'pass'

            if 'items' in resultjson:
                if 'owner' in resultjson['items']:
                    owner = resultjson['items']['owner']
                if 'group' in resultjson['items']:
                    group = resultjson['items']['group']
                if 'mode' in resultjson['items']:
                    mode = resultjson['items']['mode']
            tmp_vars['checkvalue1'] = "%s:%s %s" % (owner, group, mode)
        else:
            ret_code = -2
            ret_msg = 'Result format is incorrect.'

    rc1, out = curtemplate.render(runcontext.get_template_file('r_2_2_1_5.j2'), **tmp_vars)
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
